// Copyright 2017 FoxyUtils ehf. All rights reserved.
//
// DO NOT EDIT: generated by gooxml ECMA-376 generator
//
// Use of this source code is governed by the terms of the Affero GNU General
// Public License version 3.0 as published by the Free Software Foundation and
// appearing in the file LICENSE included in the packaging of this file. A
// commercial license can be purchased via https://unidoc.io website.

package dml

import (
	"encoding/xml"
	"fmt"

	"github.com/unidoc/unioffice"
)

type CT_ColorSchemeList struct {
	ExtraClrScheme []*CT_ColorSchemeAndMapping
}

func NewCT_ColorSchemeList() *CT_ColorSchemeList {
	ret := &CT_ColorSchemeList{}
	return ret
}

func (m *CT_ColorSchemeList) MarshalXML(e *xml.Encoder, start xml.StartElement) error {
	e.EncodeToken(start)
	if m.ExtraClrScheme != nil {
		seextraClrScheme := xml.StartElement{Name: xml.Name{Local: "a:extraClrScheme"}}
		for _, c := range m.ExtraClrScheme {
			e.EncodeElement(c, seextraClrScheme)
		}
	}
	e.EncodeToken(xml.EndElement{Name: start.Name})
	return nil
}

func (m *CT_ColorSchemeList) UnmarshalXML(d *xml.Decoder, start xml.StartElement) error {
	// initialize to default
lCT_ColorSchemeList:
	for {
		tok, err := d.Token()
		if err != nil {
			return err
		}
		switch el := tok.(type) {
		case xml.StartElement:
			switch el.Name {
			case xml.Name{Space: "http://schemas.openxmlformats.org/drawingml/2006/main", Local: "extraClrScheme"},
				xml.Name{Space: "http://purl.oclc.org/ooxml/drawingml/main", Local: "extraClrScheme"}:
				tmp := NewCT_ColorSchemeAndMapping()
				if err := d.DecodeElement(tmp, &el); err != nil {
					return err
				}
				m.ExtraClrScheme = append(m.ExtraClrScheme, tmp)
			default:
				unioffice.Log("skipping unsupported element on CT_ColorSchemeList %v", el.Name)
				if err := d.Skip(); err != nil {
					return err
				}
			}
		case xml.EndElement:
			break lCT_ColorSchemeList
		case xml.CharData:
		}
	}
	return nil
}

// Validate validates the CT_ColorSchemeList and its children
func (m *CT_ColorSchemeList) Validate() error {
	return m.ValidateWithPath("CT_ColorSchemeList")
}

// ValidateWithPath validates the CT_ColorSchemeList and its children, prefixing error messages with path
func (m *CT_ColorSchemeList) ValidateWithPath(path string) error {
	for i, v := range m.ExtraClrScheme {
		if err := v.ValidateWithPath(fmt.Sprintf("%s/ExtraClrScheme[%d]", path, i)); err != nil {
			return err
		}
	}
	return nil
}
