// Copyright 2017 FoxyUtils ehf. All rights reserved.
//
// DO NOT EDIT: generated by gooxml ECMA-376 generator
//
// Use of this source code is governed by the terms of the Affero GNU General
// Public License version 3.0 as published by the Free Software Foundation and
// appearing in the file LICENSE included in the packaging of this file. A
// commercial license can be purchased via https://unidoc.io website.

package sml

import (
	"encoding/xml"
	"fmt"
	"strconv"
)

type CT_Location struct {
	// Reference
	RefAttr string
	// First Header Row
	FirstHeaderRowAttr uint32
	// PivotTable Data First Row
	FirstDataRowAttr uint32
	// First Data Column
	FirstDataColAttr uint32
	// Rows Per Page Count
	RowPageCountAttr *uint32
	// Columns Per Page
	ColPageCountAttr *uint32
}

func NewCT_Location() *CT_Location {
	ret := &CT_Location{}
	return ret
}

func (m *CT_Location) MarshalXML(e *xml.Encoder, start xml.StartElement) error {
	start.Attr = append(start.Attr, xml.Attr{Name: xml.Name{Local: "ref"},
		Value: fmt.Sprintf("%v", m.RefAttr)})
	start.Attr = append(start.Attr, xml.Attr{Name: xml.Name{Local: "firstHeaderRow"},
		Value: fmt.Sprintf("%v", m.FirstHeaderRowAttr)})
	start.Attr = append(start.Attr, xml.Attr{Name: xml.Name{Local: "firstDataRow"},
		Value: fmt.Sprintf("%v", m.FirstDataRowAttr)})
	start.Attr = append(start.Attr, xml.Attr{Name: xml.Name{Local: "firstDataCol"},
		Value: fmt.Sprintf("%v", m.FirstDataColAttr)})
	if m.RowPageCountAttr != nil {
		start.Attr = append(start.Attr, xml.Attr{Name: xml.Name{Local: "rowPageCount"},
			Value: fmt.Sprintf("%v", *m.RowPageCountAttr)})
	}
	if m.ColPageCountAttr != nil {
		start.Attr = append(start.Attr, xml.Attr{Name: xml.Name{Local: "colPageCount"},
			Value: fmt.Sprintf("%v", *m.ColPageCountAttr)})
	}
	e.EncodeToken(start)
	e.EncodeToken(xml.EndElement{Name: start.Name})
	return nil
}

func (m *CT_Location) UnmarshalXML(d *xml.Decoder, start xml.StartElement) error {
	// initialize to default
	for _, attr := range start.Attr {
		if attr.Name.Local == "ref" {
			parsed, err := attr.Value, error(nil)
			if err != nil {
				return err
			}
			m.RefAttr = parsed
			continue
		}
		if attr.Name.Local == "firstHeaderRow" {
			parsed, err := strconv.ParseUint(attr.Value, 10, 32)
			if err != nil {
				return err
			}
			m.FirstHeaderRowAttr = uint32(parsed)
			continue
		}
		if attr.Name.Local == "firstDataRow" {
			parsed, err := strconv.ParseUint(attr.Value, 10, 32)
			if err != nil {
				return err
			}
			m.FirstDataRowAttr = uint32(parsed)
			continue
		}
		if attr.Name.Local == "firstDataCol" {
			parsed, err := strconv.ParseUint(attr.Value, 10, 32)
			if err != nil {
				return err
			}
			m.FirstDataColAttr = uint32(parsed)
			continue
		}
		if attr.Name.Local == "rowPageCount" {
			parsed, err := strconv.ParseUint(attr.Value, 10, 32)
			if err != nil {
				return err
			}
			pt := uint32(parsed)
			m.RowPageCountAttr = &pt
			continue
		}
		if attr.Name.Local == "colPageCount" {
			parsed, err := strconv.ParseUint(attr.Value, 10, 32)
			if err != nil {
				return err
			}
			pt := uint32(parsed)
			m.ColPageCountAttr = &pt
			continue
		}
	}
	// skip any extensions we may find, but don't support
	for {
		tok, err := d.Token()
		if err != nil {
			return fmt.Errorf("parsing CT_Location: %s", err)
		}
		if el, ok := tok.(xml.EndElement); ok && el.Name == start.Name {
			break
		}
	}
	return nil
}

// Validate validates the CT_Location and its children
func (m *CT_Location) Validate() error {
	return m.ValidateWithPath("CT_Location")
}

// ValidateWithPath validates the CT_Location and its children, prefixing error messages with path
func (m *CT_Location) ValidateWithPath(path string) error {
	return nil
}
